import random
import math
random.seed("basic02/gasorposorp")

class TestGen:
    def __init__(self):
        self.test_number = 0

    def generate_samples(self):
        self.print_test(5, 3, 3)
        self.print_test(5, 3, 2)

    def generate_min_tests(self):
        self.print_test(5, 0, 2)
        self.print_test(5, 0, 3)
        self.print_test(5, 0, 10)
        self.print_test(1, 0, 3)
        self.print_test(1, 0, 4)
        self.print_test(2, 2, 7)
        self.print_test(2, 2, 10)

    def generate_hand_tests(self):
        pass

    def generate_random_test(self, maxn, maxm, maxk):
        n = random.randint(1, maxn)
        m = random.randint(0, maxm)
        k = random.randint(2, maxk)
        self.print_test(n, m, k)

    def generate_max_tests(self, maxn, maxm):
        self.print_test(1, 1000, 10)
        self.print_test(1000, 1000, 10)
        self.print_test(1000, 0, 10)
        self.print_test(1000, 1, 10)
        self.print_test(1000, 2, 10)
        self.print_test(1000, 0, 9)
        self.print_test(1000, 1, 9)
        self.print_test(1000, 2, 9)
        self.print_test(1000, 1000, 9)
        
    def print_test(self, n, m, k):
        self.test_number += 1
        print('Generating test #%d' % self.test_number)

        test_name = "{0:0=2d}".format(self.test_number)
        test_file = open(test_name, 'w')
        print(n, m, k, file=test_file)
        test_file.close()

    def generate_all_tests(self):
        self.generate_samples()
        self.generate_min_tests()
        self.generate_hand_tests()
        
        ns = [5, 10, 50, 100, 10**3]
        ms = [0, 1, 3, 10, 50, 100, 10**3]
        for n in ns:
            for m in ms:
                self.generate_random_test(n, m, random.randint(2, 10))
        self.generate_max_tests(10**3, 10**3)

import time
start = time.time()
writer = TestGen()
writer.generate_all_tests()
finish = time.time()
print('All tests were generated. Elapsed time: ', finish - start)
