#include "testlib.h"
#include <bits/stdc++.h>

int main(int argc, char *argv[]) {
  registerInteraction(argc, argv);
  int n = inf.readInt();
  int m = inf.readInt();
  int k = inf.readInt();
  std::vector<bool> win(n + 1, false);
  for (int i = 2; i <= n; i++) {
    for (int j = std::max(1, i - m); j < i; j++) {
      win[i] = win[i] | !win[j];
    }
  }

  printf("%d %d %d\n", n, m, k);
  fflush(stdout);
  int previousNumber = n;
  int cnt = 1;
  while (true) {
    std::string sx = ouf.readLine();
    if (sx == "I'm giving up") {
      if (!win[n] && k % 2 == 0) {
        quitf(_ok, "lost");
      } else {
        quitf(_wa, "Participant could win, but lost");
      }
    }
    int x = -1;
    try {
      x = std::stoi(sx);
    } catch (std::exception e) {
      quitf(_wa, "Expected integer, but found %s", sx);
    }
    if (previousNumber < x || x < previousNumber - m) {
      quitf(_wa, "Expected number in [%d, %d], but found %d", previousNumber - m, previousNumber, x);
    }
    if (x == previousNumber) {
      cnt++;
    } else {
      cnt = 1;
    }
    if (cnt == k) {
      quitf(_wa, "Number %d repeated k=%d times", x, k);
    }
    if (x == 1 && cnt == k - 1) {
      printf("I'm giving up\n");
      fflush(stdout);
      quitf(_ok, "won");
    }
    std::vector<int> loosingPositions;
    for (int i = x - 1; i >= std::max(x - m, 1); i--) {
      if (!win[i]) {
        loosingPositions.push_back(i);
      }
    }
    if (!win[x] && cnt + 1 < k) {
      loosingPositions.push_back(x);
    }
    if (!loosingPositions.empty()) {
      if (loosingPositions.back() == x) {
        printf("%d\n", x);
        fflush(stdout);
        cnt++;
        previousNumber = x;
      } else {
        int val = loosingPositions[rnd.next(loosingPositions.size())];
        printf("%d\n", val);
        fflush(stdout);
        if (val == x) {
          cnt++;
        } else {
          cnt = 1;
        }
        previousNumber = val;
      }
    } else {
      int l = std::max(1, x - m);
      int r = x - 1;
      if (cnt + 1 < k) {
        r++;
      }
      if (l > r) {
        printf("I'm giving up\n");
        fflush(stdout);
        quitf(_ok, "won");
      } else {
        int val = rnd.next(l, r);
        printf("%d\n", val);
        fflush(stdout);
        if (val == x) {
          cnt++;
        } else {
          cnt = 1;
        }
        previousNumber = val;
      }
    }
  }
  return 0;
}

