#include <iostream>
#include <stdio.h>
#include <algorithm>
#include <cmath>
#include <vector>
#include <cstdlib>
#include <utility>
#include <memory.h>
#include <cassert>
#include <iterator>
#include <bitset>
#include <iomanip>
#include <complex>
#include <queue>
#include <ctime>
#include <deque>
#include <stack>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>

using namespace std;

#define pb push_back
#define mp make_pair
#define F first
#define S second

const int N = 100500;
const int mod = 786433;
const size_t MAX_PRICE = 50005;
const long double PI = acos(-1.0);

typedef complex<long double> base;

int n, k, q;
int cost[N];
int psum[MAX_PRICE];

void fft(vector<base> &a, bool invert) {
    int n = (int)a.size();
    if (n == 1) {
        return;
    }
    vector<base> a0(n/2);
    vector<base> a1(n/2);
    for (int i = 0, j = 0; i < n; i += 2, ++j) {
        a0[j] = a[i];
        a1[j] = a[i + 1];
    }
    fft (a0, invert);
    fft (a1, invert);
    long double ang = 2 * PI / n * (invert ? -1 : 1);
    base w (1),  wn (cos(ang), sin(ang));
    for (int i = 0; i < n / 2; ++i) {
        a[i] = a0[i] + w * a1[i];
        a[i+n / 2] = a0[i] - w * a1[i];
        if (invert) {
            a[i] /= 2;
            a[i+n/2] /= 2;
        }
        w *= wn;
    }
}

void multiply(const vector<int> & a, const vector<int> & b, vector<int> & res) {
    vector<base> fa (a.begin(), a.end()),  fb (b.begin(), b.end());
    size_t n = 1;
    while (n < max (a.size(), b.size()))  n <<= 1;
    n <<= 1;
    fa.resize(n);
    fb.resize(n);
    fft(fa, false);
    fft(fb, false);
    for (size_t i = 0; i < n; ++i) {
        fa[i] *= fb[i];
    }
    fft(fa, true);
    size_t res_size = min(n, MAX_PRICE);
    res.resize(res_size);
    for (size_t i=0; i < res_size; ++i) {
        long long x = (long long)(fa[i].real() + 0.5);
        x %= (long long)mod;
        res[i] = (int)x;
    }
}

int main() {
    scanf("%d%d%d", &n, &k, &q);
    int maxCost = 0;
    for (int i = 1; i <= n; ++i) {
        scanf("%d", &cost[i]);
        maxCost = max(maxCost, cost[i]);
    }
    vector<int> ways(maxCost + 5, 0);
    for (int i = 1; i <= n; ++i) {
        ++ways[cost[i]];
    }
    vector<int> result = ways;
    --k;
    while (k > 0) {
        if (k & 1) {
            multiply(result, ways, result);
        }
        multiply(ways, ways, ways);
        k >>= 1;
    }
    while ((int)result.size() < MAX_PRICE) result.emplace_back(0);
    psum[0] = result[0];
    for (int i = 1; i < MAX_PRICE; ++i) {
        psum[i] = psum[i - 1] + result[i];
        if (psum[i] >= mod) {
            psum[i] -= mod;
        }
    }
    while (q--) {
        int l, r;
        scanf("%d%d", &l, &r);
        int result = psum[r];
        if (l > 0) {
            result -= psum[l - 1];
        }
        while (result < 0) {
            result += mod;
        }
        while (result >= mod) {
            result -= mod;
        }
        printf("%d\n", result);
    }
    return 0;
}
